package config

const (
	FlagSudoDesc                       = "super user command"
	FlagNoTruncDesc                    = "Do not truncate output"
	FlagFollowDesc                     = "Follow log output"
	FlagGrepDesc                       = "pipe to grep parameters"
	FlagGrepOptsDesc                   = "grep options"
	FlagYesDesc                        = "don't ask for confirmation when %v"
	FlagRmDetachDesc                   = "don't wait for stack ressources to be released"
	FlagUpDetachDesc                   = "don't wait for old stack containers to be released"
	FlagRmVolumesDesc                  = "delete stack's volumes"
	FlagKeepLatestDesc                 = "do not remove latest"
	FlagBuildsDirDesc                  = "directory containing config and env for builds"
	FlagDeployDirDesc                  = "directory containing docker stack compose files and env"
	FlagDeployBundlesDirDesc           = "target for stack bundles generated"
	FlagDeployLocksDirDesc             = "target for random secrets rotation locks"
	FlagServiceDevTagDesc              = "set ${SERVICE}_TAG=$TYR_DEV_TAG by default, possibles values auto,true,false"
	FlagSharedFileDesc                 = "jsonnet file containing shared ressources compose files"
	FlagSharedEnvDirDesc               = "directory containing shared env files"
	FlagComposeVersionDesc             = "default docker compose file version"
	FlagForcePullDesc                  = "force pull even if image already exists"
	FlagIgnoreTagsDesc                 = "ignore tags"
	FlagIgnoreDevTagDesc               = "ignore dev-tag"
	FlagBuildCleanEnvDesc              = "don't use local environment"
	FlagBuildComposeFileDesc           = ""
	FlagBuildDepsDesc                  = "build dependencies"
	FlagBuildMissingDepsDesc           = "build missing dependencies"
	FlagBuildParametersDesc            = "build parameters"
	FlagPullDesc                       = "pull before up"
	FlagPullForceDesc                  = "force pull even if image already exists"
	FlagPullIgnoreTagsDesc             = "ignore tags on pull"
	FlagPullIgnoreDevTagDesc           = "ignore dev-tag on pull"
	FlagBuildDesc                      = ""
	FlagBuildMissingDesc               = ""
	FlagPrepareDesc                    = "only build, pull, bundle and create networks"
	FlagBundleUpdateImageDesc          = "add label to update service if it's image changed"
	FlagBundleUpdateStackDesc          = "add label to update services if stack definition or env changed"
	FlagConfigDesc                     = "tyr config file (default is tyr.yml in . or /etc)"
	FlagMachineIdDesc                  = "machine id (default from /var/lib/dbus/machine-id)"
	FlagDevTagDesc                     = "dev tag for docker services images"
	FlagStackDesc                      = "stack scope"
	FlagCWDDesc                        = "current working directory"
	FlagLogLevelDesc                   = "log level panic|fatal|error|warning|info|debug|trace"
	FlagLogTypeDesc                    = "log type json|text"
	FlagLogForceColorsDesc             = "force log colors for text log when no tty"
	FlagEnvDesc                        = "env list"
	FlagBundleValidateDesc             = "validate bundle compose file using docker-compose"
	FlagBundleDesc                     = "create bundles"
	FlagForceBundleDesc                = "recreate bundles"
	FlagNamespaceDesc                  = "default namespace (stack,network,volume,secret,config)"
	FlagStackNamespaceDesc             = "stacks namespace"
	FlagNetworkNamespaceDesc           = "networks namespace"
	FlagVolumeNamespaceDesc            = "volumes namespace"
	FlagSecretNamespaceDesc            = "secrets namespace"
	FlagConfigNamespaceDesc            = "configs namespace"
	FlagLsServicesShortDesc            = "services without stack namespace"
	FlagLabelsNamespaceDesc            = "tyr labels namespace"
	FlagCryptoKeyDesc                  = "crypto key"
	FlagCryptoKeyFileDesc              = "file containing crypto key for autoload"
	FlagRandomSizeDesc                 = "crypto random size"
	FlagRandomPrefixDesc               = "crypto random prefix"
	FlagRandomLockDesc                 = "create a lock deletable by service to release rotation on a secret"
	FlagRotateRandomForceDesc          = "force rotation"
	FlagRotateRandomForceLockDesc      = "force rotation lock"
	FlagRotateRandomIntervalDesc       = "rotation time interval"
	FlagCreateSecretDisplayDesc        = "display secret"
	FlagEncryptDataDesc                = "plaintext data to encrypt"
	FlagDecryptDataDesc                = "plaintext data to decrypt"
	FlagRotateRandomUpdateServicesDesc = "update service using rotated random secrets"
	FlagRandomRegexDesc                = "regex used to generate random value"
	FlagRandomCharsDesc                = "chars used to generate random value"
	FlagShBashDesc                     = "try to use bash when is available in container"
)

var (
	FlagCryptoKeyMissingMsg = "crypto-key flag, env or config required"
)

var (
	FlagSudoDefault                       = "sudo"
	FlagNoTruncDefault                    = true
	FlagFollowDefault                     = true
	FlagGrepDefault                       = ""
	FlagGrepOptsDefault                   = []string{}
	FlagYesDefault                        = false
	FlagUpDetachDefault                   = false
	FlagRmDetachDefault                   = false
	FlagRmVolumesDefault                  = false
	FlagKeepLatestDefault                 = true
	FlagBuildsDirDefault                  = "builds"
	FlagDeployDirDefault                  = "deploy"
	FlagDeployBundlesDirDefault           = "deploy.bundles"
	FlagDeployLocksDirDefault             = "deploy.locks"
	FlagServiceDevTagDefault              = "auto"
	FlagSharedFileDefault                 = "deploy/shared/common.jsonnet"
	FlagSharedEnvDirDefault               = "deploy/shared"
	FlagComposeVersionDefault             = ""
	FlagForceDefault                      = false
	FlagIgnoreTagsDefault                 = []string{}
	FlagIgnoreDevTagDefault               = true
	FlagBuildCleanEnvDefault              = false
	FlagBuildComposeFileDefault           = "docker-compose.yml"
	FlagBuildDepsDefault                  = false
	FlagBuildMissingDepsDefault           = true
	FlagBuildParametersDefault            = []string{}
	FlagPullDefault                       = true
	FlagPullForceDefault                  = false
	FlagPullIgnoreTagsDefault             = []string{}
	FlagPullIgnoreDevTagDefault           = true
	FlagBuildDefault                      = false
	FlagBuildMissingDefault               = true
	FlagPrepareDefault                    = false
	FlagBundleUpdateImageDefault          = true
	FlagBundleUpdateStackDefault          = true
	FlagLogForceColorsDefault             = false
	FlagLogTypeDefault                    = "json"
	FlagLogLevelDefault                   = "info"
	FlagBundleValidateDefault             = true
	FlagBundleDefault                     = true
	FlagLsServicesShortDefault            = false
	FlagLabelsNamespaceDefault            = "earth.youtopia.tyr"
	FlagCryptoKeyDefault                  = ""
	FlagCryptoKeyFileDefault              = ".tyr-crypto-key"
	FlagRandomSizeDefault                 = 64
	FlagRandomPrefixDefault               = ""
	FlagRotateRandomForceDefault          = false
	FlagRotateRandomForceLockDefault      = false
	FlagRotateRandomIntervalDefault       = "24h"
	FlagCreateSecretDisplayDefault        = false
	FlagRotateRandomUpdateServicesDefault = false
	FlagRandomRegexDefault                = ""
	FlagRandomCharsDefault                = ""
	FlagRandomLockDefault                 = false
	FlagShBashDefault                     = true
)
